//---------------------------------
// 2022/11/7

#ifndef INFRAREDREC_H
#define INFRAREDREC_H

#include "Arduino.h"


class InfraredRec{
private:
  uint8_t recGPIO;  // Receiver GPIO
  
  uint32_t receivePulse(uint32_t timeout);
  uint8_t checkFormat(uint32_t firstPulse);
  bool checkRepeat(uint8_t format, uint32_t firstPulse);
  uint8_t readFrame(uint8_t*buf, uint32_t timeout);


public:
  static const uint8_t maxFrameSize = 64;  // 最大フレームサイズ
  static const uint8_t maxFrameCount = 8;  // 最大フレーム数

  // 赤外線フォーマット
  static const uint8_t formatUnknown = 0;
  static const uint8_t formatNEC = 1;
  static const uint8_t formatAEHA = 2;
  static const uint8_t formatSONY = 3;

  // 一部関数の戻り値
  static const uint8_t readTimeout = 0xFF;
  static const uint8_t readUnknown = 0xFE;
  static const uint8_t readSuccess = 0;


  uint8_t format;  // 受信したデータのフォーマット
  uint8_t frameCount;  // 受信したデータのフレーム数
  uint8_t frameSize[maxFrameSize];  // 受信したそれぞれのフレームのサイズ
  uint8_t frameData[maxFrameCount][maxFrameSize];  // 受信したデータ

  InfraredRec(uint8_t setGPIO);
  uint8_t readData();
};

#endif

